
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY MAC_DFSM_tb IS
END MAC_DFSM_tb;
 
ARCHITECTURE behavior OF MAC_DFSM_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT MAC_DFSM
    PORT(
         b : IN  std_logic;
         i : IN  integer range 0 to 255;
         clk : IN  std_logic;
         rst : IN  std_logic;
         done : OUT  std_logic;
         valid : OUT  std_logic;
         cnt : OUT  integer range 0 to 255;
         acc : OUT  integer range 0 to 65280
        );
    END COMPONENT;
    

   --Inputs
   signal b : std_logic := '0';
   signal i : integer range 0 to 255 := 0;
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';

 	--Outputs
   signal done : std_logic;
   signal valid : std_logic;
   signal cnt : integer range 0 to 255;
   signal acc : integer range 0 to 65280;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: MAC_DFSM PORT MAP (
          b => b,
          i => i,
          clk => clk,
          rst => rst,
          done => done,
          valid => valid,
          cnt => cnt,
          acc => acc
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	
		rst <= '1';
      wait for clk_period;
		rst <= '0';
		wait for clk_period;
		b <= '1';
		i <= 1;
		wait for clk_period;
		b <= '0';
		i <= 2;
		wait for clk_period;
		i <= 3;
		wait for clk_period;
		b <= '1';
		i <= 4;
		wait for clk_period;
		i <= 5;
		wait for clk_period;
		b <= '0';
		wait for clk_period;
		b <= '1';
		i <= 1;
		wait for clk_period;
		i <= 2;
		wait for clk_period;
		i <= 3;
		wait for clk_period;
		i <= 4;
		wait for clk_period;
		i <= 5;
		wait for clk_period;
		i <= 6;
		wait for clk_period;
		i <= 200;
      -- insert stimulus here 

   end process;

END;
