library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use work.sing_stat_package.all;

entity FSM_w_dp is
	port ( transition_sig, conf_en, reset, clk, fsm_en: in std_logic;
			 conf_vec_0, conf_vec_1, conf_vec_2, conf_vec_3: in conf_info;
			 input_data: in integer range 0 to 255;
			 done, valid : out std_logic;
			-- cnt: out integer range 0 to 255;
			 result : out integer range 0 to 65280
	);

end FSM_w_dp;

architecture Behavioral of FSM_w_dp is

component FSM_macro
	port (input, conf_en,reset, clk, fsm_en: in std_logic;
			conf_vec_0_0, conf_vec_0_1, conf_vec_0_2, conf_vec_0_3, conf_vec_0_4: in std_logic;
			conf_vec_1_0, conf_vec_1_1, conf_vec_1_2, conf_vec_1_3, conf_vec_1_4: in std_logic;
			conf_vec_2_0, conf_vec_2_1, conf_vec_2_2, conf_vec_2_3, conf_vec_2_4: in std_logic;
			conf_vec_3_0, conf_vec_3_1, conf_vec_3_2, conf_vec_3_3, conf_vec_3_4: in std_logic;
			state_vector_0, state_vector_1, state_vector_2, state_vector_3: out std_logic
			);
end component;

component data_path
    port ( clk : in std_logic;
			  state_vector: in std_logic_vector(3 downto 0);
			  i : in integer range 0 to 255;	-- Input values corresponding to the enable signal
			  done, valid : out std_logic;   -- if there is atleast one valid result valid and done should be high.
           acc : out  integer range 0 to 65280 -- Result vector
			  );    
end component;

signal state_vector: std_logic_vector(3 downto 0);

-- add component for data path
begin
	t0: FSM_macro port map(
		-- connect data path to FSM
		input => transition_sig,
		conf_en => conf_en,
		reset => reset,
		clk => clk,
		fsm_en => fsm_en,
		conf_vec_0_0 => conf_vec_0(0),
		conf_vec_0_1 => conf_vec_0(1),
		conf_vec_0_2 => conf_vec_0(2),
		conf_vec_0_3 => conf_vec_0(3),
		conf_vec_0_4 => conf_vec_0(4),
		conf_vec_1_0 => conf_vec_1(0),
		conf_vec_1_1 => conf_vec_1(1),
		conf_vec_1_2 => conf_vec_1(2),
		conf_vec_1_3 => conf_vec_1(3),
		conf_vec_1_4 => conf_vec_1(4),
		conf_vec_2_0 => conf_vec_2(0),
		conf_vec_2_1 => conf_vec_2(1),
		conf_vec_2_2 => conf_vec_2(2),
		conf_vec_2_3 => conf_vec_2(3),
		conf_vec_2_4 => conf_vec_2(4),
		conf_vec_3_0 => conf_vec_3(0),
		conf_vec_3_1 => conf_vec_3(1),
		conf_vec_3_2 => conf_vec_3(2),
		conf_vec_3_3 => conf_vec_3(3),
		conf_vec_3_4 => conf_vec_3(4),
		state_vector_0 => state_vector(0),
		state_vector_1 => state_vector(1),
		state_vector_2 => state_vector(2),
		state_vector_3 => state_vector(3)
	);
	
	d0: data_path port map(
		clk => clk,
		i => input_data,
		done => done,
		valid => valid,
	--	cnt => cnt,
		acc => result,
		state_vector => state_vector
	);

end Behavioral;

