library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use work.sing_stat_package.all;

entity top_level is
	port (input, conf_en,reset, clk, fsm_en: in std_logic;
			conf_vec_0, conf_vec_1 ,conf_vec_2, conf_vec_3: conf_info;
			state_vector: out std_logic_vector((FSM_SIZE-1) downto 0)
			);
end top_level;

architecture Behavioral of top_level is

component singular_state
	port (input, reset, clk, fsm_en: in std_logic;
			en0, en1, en2, en3: in std_logic;
			conf_en: in std_logic;
			conf_bits: in conf_info;
			ext_enable: out std_logic
			);
end component;


signal state0, state1, state2, state3: std_logic;

begin
	s0: singular_state port map (
		input=>input, 
		reset=>reset, 
		clk => clk,
		fsm_en => fsm_en,
		conf_en => conf_en,
		conf_bits => conf_vec_0,
		en0 => state0,
		en1 => state1,
		en2 => state2,
		en3 => state3,
		ext_enable => state0
		);

	s1: singular_state port map (
		input=>input, 
		reset=>reset, 
		clk => clk,
		fsm_en => fsm_en,
		conf_en => conf_en,
		conf_bits => conf_vec_1,
		en0 => state0,
		en1 => state1,
		en2 => state2,
		en3 => state3,
		ext_enable => state1
		);

	s2: singular_state port map (
		input=>input, 
		reset=>reset, 
		clk => clk,
		fsm_en => fsm_en,
		conf_en => conf_en,
		conf_bits =>conf_vec_2,
		en0 => state0,
		en1 => state1,
		en2 => state2,
		en3 => state3,
		ext_enable => state2
		);
		
	s3: singular_state port map (
		input=>input, 
		reset=>reset, 
		clk => clk,
		fsm_en => fsm_en,
		conf_en => conf_en,
		conf_bits =>conf_vec_3,
		en0 => state0,
		en1 => state1,
		en2 => state2,
		en3 => state3,
		ext_enable => state3
		);

		state_vector(0) <= state0;
		state_vector(1) <= state1;
		state_vector(2) <= state2;
		state_vector(3) <= state3;
end Behavioral;

