library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use work.sing_stat_package.all;

entity very_top_level is
	port ( transition_sig, conf_en, reset, clk, fsm_en: in std_logic;
			 conf_vec_0, conf_vec_1, conf_vec_2, conf_vec_3: in conf_info;
			 input_data: in integer range 0 to 255;
			 done, valid : out std_logic;
			 result : out integer range 0 to 65280
	);

end very_top_level;

architecture Behavioral of very_top_level is

component top_level
	port (input, conf_en,reset, clk, fsm_en: in std_logic;
			conf_vec_0, conf_vec_1 ,conf_vec_2, conf_vec_3: conf_info;
			state_vector: out std_logic_vector((FSM_SIZE-1) downto 0)
			);
end component;

component data_path
    port ( clk : in std_logic;
			  state_vector: in std_logic_vector((FSM_SIZE-1) downto 0);
			  i : in integer range 0 to 255;
			  done, valid : out std_logic;   -- if there is atleast one valid result valid and done should be high.
           acc : out  integer range 0 to 65280 -- Result vector
			  );    
end component;

signal state_vector: std_logic_vector((FSM_SIZE-1) downto 0);

begin
	t0: top_level port map(
		input => transition_sig,
		conf_en => conf_en,
		reset => reset,
		clk => clk,
		fsm_en => fsm_en,
		conf_vec_0 => conf_vec_0,
		conf_vec_1 => conf_vec_1,
		conf_vec_2 => conf_vec_2,
		conf_vec_3 => conf_vec_3,
		state_vector => state_vector
	);
	
	d0: data_path port map(
		clk => clk,
		i => input_data,
		done => done,
		valid => valid,
		acc => result,
		state_vector => state_vector
	);

end Behavioral;

